function widgetOnMsg(MsgString)
{
   if(MsgString=="widget_6_close")widget.cmd("!Close");
}

if (typeof JSON !== 'object') {
    JSON = {};
}

(function () {
    'use strict';

function f(n) {
        return n < 10 ? '0' + n : n;
    }
    if (typeof Date.prototype.toJSON !== 'function') {
        Date.prototype.toJSON = function () {
            return isFinite(this.valueOf())
                ? this.getUTCFullYear()     + '-' +
                    f(this.getUTCMonth() + 1) + '-' +
                    f(this.getUTCDate())      + 'T' +
                    f(this.getUTCHours())     + ':' +
                    f(this.getUTCMinutes())   + ':' +
                    f(this.getUTCSeconds())   + 'Z'
                : null;
        };
         String.prototype.toJSON      =
            Number.prototype.toJSON  =
            Boolean.prototype.toJSON = function () {
                return this.valueOf();
            };
    }
    var cx,
        escapable,
        gap,
        indent,
        meta,
        rep;

function quote(string) {
        escapable.lastIndex = 0;
        return escapable.test(string) ? '"' + string.replace(escapable, function (a) {
            var c = meta[a];
            return typeof c === 'string'
                ? c
                : '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
        }) + '"' : '"' + string + '"';
    }

function str(key, holder) {
        var i,
            k,
            v,
            length,
            mind = gap,
            partial,
            value = holder[key];
        if (value && typeof value === 'object' &&
                typeof value.toJSON === 'function') {
            value = value.toJSON(key);
        }
        if (typeof rep === 'function') {
            value = rep.call(holder, key, value);
        }
        switch (typeof value) {
        case 'string':
            return quote(value);
        case 'number':
            return isFinite(value) ? String(value) : 'null';
        case 'boolean':
        case 'null':
            return String(value);
        case 'object':
            if (!value) {
                return 'null';
            }
            gap += indent;
            partial = [];
            if (Object.prototype.toString.apply(value) === '[object Array]') {
                length = value.length;
                for (i = 0; i < length; i += 1) {
                    partial[i] = str(i, value) || 'null';
                }
                v = partial.length === 0
                    ? '[]'
                    : gap
                    ? '[\n' + gap + partial.join(',\n' + gap) + '\n' + mind + ']'
                    : '[' + partial.join(',') + ']';
                gap = mind;
                return v;
            }
            if (rep && typeof rep === 'object') {
                length = rep.length;
                for (i = 0; i < length; i += 1) {
                    if (typeof rep[i] === 'string') {
                        k = rep[i];
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            } else {
                for (k in value) {
                    if (Object.prototype.hasOwnProperty.call(value, k)) {
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            }
            v = partial.length === 0
                ? '{}'
                : gap
                ? '{\n' + gap + partial.join(',\n' + gap) + '\n' + mind + '}'
                : '{' + partial.join(',') + '}';
            gap = mind;
            return v;
        }
    }
    if (typeof JSON.stringify !== 'function') {
        escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;
        meta = {
            '\b': '\\b',
            '\t': '\\t',
            '\n': '\\n',
            '\f': '\\f',
            '\r': '\\r',
            '"' : '\\"',
            '\\': '\\\\'
        };
        JSON.stringify = function (value, replacer, space) {
            var i;
            gap = '';
            indent = '';
            if (typeof space === 'number') {
                for (i = 0; i < space; i += 1) {
                    indent += ' ';
                }
            } else if (typeof space === 'string') {
                indent = space;
            }
            rep = replacer;
            if (replacer && typeof replacer !== 'function' &&
                    (typeof replacer !== 'object' ||
                    typeof replacer.length !== 'number')) {
                throw new Error('JSON.stringify');
            }
            return str('', {'': value});
        };
    }
    if (typeof JSON.parse !== 'function') {
        cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;
        JSON.parse = function (text, reviver) {
            var j;

function walk(holder, key) {
                var k, v, value = holder[key];
                if (value && typeof value === 'object') {
                    for (k in value) {
                        if (Object.prototype.hasOwnProperty.call(value, k)) {
                            v = walk(value, k);
                            if (v !== undefined) {
                                value[k] = v;
                            } else {
                                delete value[k];
                            }
                        }
                    }
                }
                return reviver.call(holder, key, value);
            }
            text = String(text);
            cx.lastIndex = 0;
            if (cx.test(text)) {
                text = text.replace(cx, function (a) {
                    return '\\u' +
                        ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
                });
            }
            if (/^[\],:{}\s]*$/
                    .test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, '@')
                        .replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']')
                        .replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                j = eval('(' + text + ')');
                return typeof reviver === 'function'
                    ? walk({'': j}, '')
                    : j;
            }
            throw new SyntaxError('JSON.parse');
        };
    }
}());

function WIDGETActuator() {
  this.scoreContainer  = scorecontainer;
  this.bestContainer   = bestcontainer;
  this.overContainer   = game_over;
  this.winContainer    = game_win;
  this.score = 0;
}

WIDGETActuator.prototype.actuate = function (grid, metadata) {
    var self = this;
    self.resetTiles();
    var movingtile_ary = new Array();
    var mergedtile_ary = new Array();
    var newtile_ary = new Array();
    for(var i in grid.cells){
       for(var j in grid.cells[i]){
	  if(grid.cells[i][j]){
             var tile = grid.cells[i][j];
             if (tile.previousPosition){
		 tile.hide = false;
                 movingtile_ary.push(tile);
             } else if (tile.mergedFrom){
                 for(var m in tile.mergedFrom){
                     tile.mergedFrom[m].hide = true;
                     movingtile_ary.push(tile.mergedFrom[m]);
                 }
                 mergedtile_ary.push(tile);
             } else  newtile_ary.push(tile);
           }
        }
    }
    for(var i in movingtile_ary) self.addmovingtile(movingtile_ary[i]);
    for(var i in mergedtile_ary) self.addmergedtile(mergedtile_ary[i],0.15);
    for(var i in newtile_ary) self.addmergedtile(newtile_ary[i],0.23);
    self.updateScore(metadata.score);
    self.updateBestScore(metadata.bestScore);
    if (metadata.terminated) {
      if (metadata.over) {
        self.message(false);
      } else if (metadata.won) {
        self.message(true);
      }
    }
};

WIDGETActuator.prototype.continueGame = function () {
  this.clearMessage();
};

WIDGETActuator.prototype.resetTiles = function (container) {
  for(var i=1;i<=4;i++)
     for(var j=1;j<=4;j++)
     {
        eval('mtile'+i+j).left = 5 + (i-1) * 90;
        eval('mtile'+i+j).top  = 5 + (j-1) * 90;
        eval('mtile'+i+j).visible = false;

        eval('ntile'+i+j).visible = false;
     }
};

WIDGETActuator.prototype.addmovingtile = function (tile) {
  var column  = tile.previousPosition.x+1;
  var row = tile.previousPosition.y+1;
  var tilecontrol = eval("mtile" + column + row);
  tilecontrol.visible = true;
  tilecontrol.src = "tiles\\tile" + tile.value + ".png";
  var nleft = 5 + tile.x * 90;
  var ntop  = 5 + tile.y * 90;
  tilecontrol.moveto(nleft,ntop,0.16,0,0,0,tile.hide);
};

WIDGETActuator.prototype.addmergedtile = function (tile,delay) {
  var column = tile.x + 1;
  var row = tile.y + 1;
  var tilecontrol = eval("ntile" + column + row);
  tilecontrol.visible = true;
  tilecontrol.src = "tiles\\tile" + tile.value + ".png";
  tilecontrol.scaleto(0.6,0.6,0,'center');
  tilecontrol.opacity = 0;
  tilecontrol.animatefloat("opacity",1,0.02,0,0,delay);
  tilecontrol.scaleto(1,1,0.2,'center',1,9,delay);
};

WIDGETActuator.prototype.updateScore = function (score) {
  var difference = score - this.score;
  this.score = score;
  this.scoreContainer.text = this.score;
  if(difference>0){
     scoreplus.text = "+" + difference;
     scoreplus.top = 20;
     scoreplus.Opacity = 1;
     scoreplus.Visible = true;
     scoreplus.MoveTo(scoreplus.left,-32,0.4,0,0,0,true);
     scoreplus.FadeTo(0.5,0.4);
  }
};

WIDGETActuator.prototype.updateBestScore = function (bestScore) {
  this.bestContainer.text = bestScore;
};

WIDGETActuator.prototype.message = function (won) {
   if(won)
   {
     this.winContainer.FadeToVisible(1,1);
     this.overContainer.Opacity = 0;
   }
   else
   {
     this.overContainer.FadeToVisible(1,1);
     this.winContainer.Opacity = 0;
   }
};

WIDGETActuator.prototype.clearMessage = function () {
  this.winContainer.Opacity = this.overContainer.Opacity = 0;
  this.winContainer.visible = this.overContainer.Visible = false;
};

function StorageManager() {
  this.bestScoreKey     = "bestScore";
  this.gameStateKey     = "gameState";
  this.path = WidgetPath + "mydata.ini";
  this.node = "mydata";
}

StorageManager.prototype.getBestScore = function () {
  return GetiniValue(this.path,this.node,this.bestScoreKey,0);
};

StorageManager.prototype.setBestScore = function (score) {
  SetIniValue(this.path,this.node,this.bestScoreKey,score);
};

StorageManager.prototype.getGameState = function () {
  var stateJSON = GetiniValue(this.path,this.node,this.gameStateKey,"");
  return stateJSON ? JSON.parse(stateJSON) : null;
};

StorageManager.prototype.setGameState = function (gameState) {
  SetIniValue(this.path,this.node,this.gameStateKey, JSON.stringify(gameState));
};

StorageManager.prototype.clearGameState = function () {
  SetIniValue(this.path,this.node,this.gameStateKey,"");
};

function Tile(position, value) {
  this.x                = position.x;
  this.y                = position.y;
  this.value            = value || 2;
  this.previousPosition = null;
  this.mergedFrom       = null;
}

Tile.prototype.savePosition = function () {
  this.previousPosition = { x: this.x, y: this.y };
};

Tile.prototype.updatePosition = function (position) {
  this.x = position.x;
  this.y = position.y;
};

Tile.prototype.serialize = function () {
  return {
    position: {
      x: this.x,
      y: this.y
    },
    value: this.value
  };
};

function Grid(size, previousState) {
  this.size = size;
  this.cells = previousState ? this.fromState(previousState) : this.empty();
}

Grid.prototype.empty = function () {
  var cells = [];
  for (var x = 0; x < this.size; x++) {
    var row = cells[x] = [];
    for (var y = 0; y < this.size; y++) {
      row.push(null);
    }
  }
  return cells;
};

Grid.prototype.fromState = function (state) {
  var cells = [];
  for (var x = 0; x < this.size; x++) {
    var row = cells[x] = [];
    for (var y = 0; y < this.size; y++) {
      var tile = state[x][y];
      row.push(tile ? new Tile(tile.position, tile.value) : null);
    }
  }
  return cells;
};

Grid.prototype.randomAvailableCell = function () {
  var cells = this.availableCells();
  if (cells.length) {
    return cells[Math.floor(Math.random() * cells.length)];
  }
};

Grid.prototype.availableCells = function () {
  var cells = [];
  this.eachCell(function (x, y, tile) {
    if (!tile) {
      cells.push({ x: x, y: y });
    }
  });
  return cells;
};

Grid.prototype.eachCell = function (callback) {
  for (var x = 0; x < this.size; x++) {
    for (var y = 0; y < this.size; y++) {
      callback(x, y, this.cells[x][y]);
    }
  }
};

Grid.prototype.cellsAvailable = function () {
  return !!this.availableCells().length;
};

Grid.prototype.cellAvailable = function (cell) {
  return !this.cellOccupied(cell);
};

Grid.prototype.cellOccupied = function (cell) {
  return !!this.cellContent(cell);
};

Grid.prototype.cellContent = function (cell) {
  if (this.withinBounds(cell)) {
    return this.cells[cell.x][cell.y];
  } else {
    return null;
  }
};

Grid.prototype.insertTile = function (tile) {
  this.cells[tile.x][tile.y] = tile;
};

Grid.prototype.removeTile = function (tile) {
  this.cells[tile.x][tile.y] = null;
};

Grid.prototype.withinBounds = function (position) {
  return position.x >= 0 && position.x < this.size &&
         position.y >= 0 && position.y < this.size;
};

Grid.prototype.serialize = function () {
  var cellState = [];
  for (var x = 0; x < this.size; x++) {
    var row = cellState[x] = [];
    for (var y = 0; y < this.size; y++) {
      row.push(this.cells[x][y] ? this.cells[x][y].serialize() : null);
    }
  }
  return {
    size: this.size,
    cells: cellState
  };
};

function GameManager(size) {
  this.size           = size;
  this.storageManager = new StorageManager;
  this.actuator       = new WIDGETActuator;
  this.startTiles     = 2;
  this.setup();
}

GameManager.prototype.restart = function () {
  this.storageManager.clearGameState();
  this.actuator.continueGame();
  this.setup();
};

GameManager.prototype.keepPlay = function () {
  this.keepPlaying = true;
  this.actuator.continueGame();
};

GameManager.prototype.isGameTerminated = function () {
  if (this.over || (this.won && !this.keepPlaying)) {
    return true;
  } else {
    return false;
  }
};

GameManager.prototype.setup = function () {
  var previousState = this.storageManager.getGameState();
  if (previousState) {
    this.grid        = new Grid(previousState.grid.size,
                                previousState.grid.cells);
    this.score       = previousState.score;
    this.over        = previousState.over;
    this.won         = previousState.won;
    this.keepPlaying = previousState.keepPlaying;
  } else {
    this.grid        = new Grid(this.size);
    this.score       = 0;
    this.over        = false;
    this.won         = false;
    this.keepPlaying = false;
    this.addStartTiles();
  }
  this.actuate();
};

GameManager.prototype.addStartTiles = function () {
  for (var i = 0; i < this.startTiles; i++) {
    this.addRandomTile();
  }
};

GameManager.prototype.addRandomTile = function () {
  if (this.grid.cellsAvailable()) {
    var value = Math.random() < 0.9 ? 2 : 4;
    var tile = new Tile(this.grid.randomAvailableCell(), value);
    this.grid.insertTile(tile);
  }
};

GameManager.prototype.actuate = function () {
  if (this.storageManager.getBestScore() < this.score) {
    this.storageManager.setBestScore(this.score);
  }

  if (this.over) {
    this.storageManager.clearGameState();
  } else {
    this.storageManager.setGameState(this.serialize());
  }

  this.busy = true;
  this.actuator.actuate(this.grid, {
    score:      this.score,
    over:       this.over,
    won:        this.won,
    bestScore:  this.storageManager.getBestScore(),
    terminated: this.isGameTerminated()
  });
  this.busy = false;
};

GameManager.prototype.serialize = function () {
  return {
    grid:        this.grid.serialize(),
    score:       this.score,
    over:        this.over,
    won:         this.won,
    keepPlaying: this.keepPlaying
  };
};

GameManager.prototype.prepareTiles = function () {
  this.grid.eachCell(function (x, y, tile) {
    if (tile) {
      tile.mergedFrom = null;
      tile.savePosition();
    }
  });
};

GameManager.prototype.moveTile = function (tile, cell) {
  this.grid.cells[tile.x][tile.y] = null;
  this.grid.cells[cell.x][cell.y] = tile;
  tile.updatePosition(cell);
};

GameManager.prototype.move = function (direction) {
  var self = this;
  if (this.isGameTerminated()) return;
  var cell, tile;
  var vector     = this.getVector(direction);
  var traversals = this.buildTraversals(vector);
  var moved      = false;
  this.prepareTiles();
  for(var x in traversals.x)
    for(var y in traversals.y){
      cell = { x: traversals.x[x], y: traversals.y[y]};
      tile = self.grid.cellContent(cell);
      if (tile) {
        var positions = self.findFarthestPosition(cell, vector);
        var next      = self.grid.cellContent(positions.next);
        if (next && next.value === tile.value && !next.mergedFrom) {
          var merged = new Tile(positions.next, tile.value * 2);
          merged.mergedFrom = [tile, next];
          self.grid.insertTile(merged);
          self.grid.removeTile(tile);
          tile.updatePosition(positions.next);
          self.score += merged.value;
          if (merged.value === 2048) self.won = true;
        } else {
          self.moveTile(tile, positions.farthest);
        }
        if (!self.positionsEqual(cell, tile)) {
          moved = true;
        }
      }
    }
  if (moved) {
    this.addRandomTile();
    if (!this.movesAvailable()) {
      this.over = true;
    }
    this.actuate();
  }
};

GameManager.prototype.getVector = function (direction) {
  var map = {
    0: { x: 0,  y: -1 },
    1: { x: 1,  y: 0 },
    2: { x: 0,  y: 1 },
    3: { x: -1, y: 0 }
  };
  return map[direction];
};

GameManager.prototype.buildTraversals = function (vector) {
  var traversals = { x: [], y: [] };
  for (var pos = 0; pos < this.size; pos++) {
    traversals.x.push(pos);
    traversals.y.push(pos);
  }
  if (vector.x === 1) traversals.x = traversals.x.reverse();
  if (vector.y === 1) traversals.y = traversals.y.reverse();
  return traversals;
};

GameManager.prototype.findFarthestPosition = function (cell, vector) {
  var previous;
  do {
    previous = cell;
    cell     = { x: previous.x + vector.x, y: previous.y + vector.y };
  } while (this.grid.withinBounds(cell) &&
           this.grid.cellAvailable(cell));
  return {
    farthest: previous,
    next: cell
  };
};

GameManager.prototype.movesAvailable = function () {
  return this.grid.cellsAvailable() || this.tileMatchesAvailable();
};

GameManager.prototype.tileMatchesAvailable = function () {
  var self = this;
  var tile;
  for (var x = 0; x < this.size; x++) {
    for (var y = 0; y < this.size; y++) {
      tile = this.grid.cellContent({ x: x, y: y });
      if (tile) {
        for (var direction = 0; direction < 4; direction++) {
          var vector = self.getVector(direction);
          var cell   = { x: x + vector.x, y: y + vector.y };
          var other  = self.grid.cellContent(cell);
          if (other && other.value === tile.value) {
            return true;
          }
        }
      }
    }
  }
  return false;
};

GameManager.prototype.positionsEqual = function (first, second) {
  return first.x === second.x && first.y === second.y;
};

var game;
function widgetOnLoad()
{
    game = new GameManager(4);
}

function again_wOnClick(Sender)
{
  game.restart();
  layer2.SetFocus();
}

function keepgoingOnClick(Sender)
{
  game.keepPlay();
  layer2.SetFocus();
}

function listen(Sender,Key,KeyChar,Shift)
{
     if(game.busy) return;
     if(Key==38 || Key==87){
        game.move(0);
     } else if(Key==39 || Key==68){
        game.move(1);
     } else if(Key==40 || Key==83){
        game.move(2);
     } else if(Key==37 || Key==65){
        game.move(3);
     } else if(Key==82 || Key==78){
        game.restart();
     } else if(Key==75){
        game.keepPlay();
     }
}
